package com.sun.jmx.snmp.internal;

import com.sun.jmx.snmp.SnmpDefinitions;

public class SnmpTools implements SnmpDefinitions
{
    public SnmpTools() {
    }
    
    public static String binary2ascii(byte[] array, int n) {
        if (array == null) {
            return null;
        }
        byte[] bytes = new byte[n * 2 + 2];
        bytes[0] = 48;
        bytes[1] = 120;
        for (int i = 0; i < n; ++i) {
            int n2 = i * 2;
            int n3 = (array[i] & 0xF0) >> 4;
            if (n3 < 10) {
                bytes[n2 + 2] = (byte)(48 + n3);
            }
            else {
                bytes[n2 + 2] = (byte)(65 + (n3 - 10));
            }
            int n4 = array[i] & 0xF;
            if (n4 < 10) {
                bytes[n2 + 1 + 2] = (byte)(48 + n4);
            }
            else {
                bytes[n2 + 1 + 2] = (byte)(65 + (n4 - 10));
            }
        }
        return new String(bytes);
    }
    
    public static String binary2ascii(byte[] array) {
        return binary2ascii(array, array.length);
    }
    
    public static byte[] ascii2binary(String s) {
        if (s == null) {
            return null;
        }
        String substring = s.substring(2);
        int length = substring.length();
        byte[] array = new byte[length / 2];
        byte[] bytes = substring.getBytes();
        int n3;
        for (int i = 0; i < length / 2; array[i] = n3, ++i) {
            int n = i * 2;
            int n2;
            if (bytes[n] >= 48 && bytes[n] <= 57) {
                n2 = (byte)(bytes[n] - 48 << 4);
            }
            else if (bytes[n] >= 97 && bytes[n] <= 102) {
                n2 = (byte)(bytes[n] - 97 + 10 << 4);
            }
            else if (bytes[n] >= 65 && bytes[n] <= 70) {
                n2 = (byte)(bytes[n] - 65 + 10 << 4);
            }
            else {
                throw new Error("BAD format :" + s);
            }
            if (bytes[n + 1] >= 48 && bytes[n + 1] <= 57) {
                n3 = (byte)(n2 + (bytes[n + 1] - 48));
            }
            else if (bytes[n + 1] >= 97 && bytes[n + 1] <= 102) {
                n3 = (byte)(n2 + (bytes[n + 1] - 97 + 10));
            }
            else if (bytes[n + 1] >= 65 && bytes[n + 1] <= 70) {
                n3 = (byte)(n2 + (bytes[n + 1] - 65 + 10));
            }
            else {
                throw new Error("BAD format :" + s);
            }
        }
        return array;
    }
}
